rpma_write_with_imm(3)

NAME
rpma_write_with_imm - initiate the write operation with immediate data

SYNOPSIS
      #include <librpma.h>

      struct rpma_conn;
      struct rpma_mr_local;
      struct rpma_mr_remote;
      int rpma_write_with_imm(struct rpma_conn *conn,
                      struct rpma_mr_remote *dst, size_t dst_offset,
                      const struct rpma_mr_local *src, size_t src_offset,
                      size_t len, int flags, uint32_t imm,
                      const void *op_context);

DESCRIPTION
rpma_write_with_imm() initiates the write operation with immediate data (transferring data from the local memory to the remote memory. To write a 0 bytes message, set src and dst to NULL and src_offset, dst_offset and len to 0.

The attribute flags set the completion notification indicator:

•   RPMA_F_COMPLETION_ON_ERROR - generate the completion on error

•   RPMA_F_COMPLETION_ALWAYS - generate the completion regardless of result of the operation.

op_context is returned in the wr_id field of the completion (struct ibv_wc).

RETURN VALUE
The rpma_write_with_imm() function returns 0 on success or a negative error code on failure.

ERRORS
rpma_write_with_imm() can fail with the following errors:

•   RPMA_E_INVAL - conn == NULL || flags == 0

•   RPMA_E_INVAL - dst == NULL && (src != NULL || src_offset != 0 || dst_offset != 0 || len != 0)

•   RPMA_E_INVAL - src == NULL && (dst != NULL || src_offset != 0 || dst_offset != 0 || len != 0)

•   RPMA_E_PROVIDER - ibv_post_send(3) failed

SEE ALSO
rpma_conn_req_connect(3), rpma_mr_reg(3), rpma_mr_remote_from_descriptor(3), librpma(7) and https://pmem.io/rpma/